/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.69 Revision 1.367
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.69 2003/11/26 22:13:35 mr_bones_ Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.367 2011/10/26 23:27:16 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
14 17
15newdepend "!bootstrap? ( sys-devel/patch )" 18inherit multilib portability
16 19
17DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
18 21
19# This function generate linker scripts in /usr/lib for dynamic 22if has "${EAPI:-0}" 0 1 2; then
20# libs in /lib. This is to fix linking problems when you have
21# the .so in /lib, and the .a in /usr/lib. What happens is that
22# in some cases when linking dynamic, the .a in /usr/lib is used
23# instead of the .so in /lib due to gcc/libtool tweaking ld's
24# library search path. This cause many builds to fail.
25# See bug #4411 for more info.
26#
27# To use, simply call:
28#
29# gen_usr_ldscript libfoo.so
30#
31# Note that you should in general use the unversioned name of
32# the library, as ldconfig should usually update it correctly
33# to point to the latest version of the library present.
34#
35# <azarah@gentoo.org> (26 Oct 2002)
36#
37gen_usr_ldscript() {
38 23
39 # Just make sure it exists 24# @FUNCTION: epause
40 dodir /usr/lib 25# @USAGE: [seconds]
41 26# @DESCRIPTION:
42 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
43/* GNU ld script 28# printing a message the user should probably be reading and often used in
44 Because Gentoo have critical dynamic libraries 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
45 in /lib, and the static versions in /usr/lib, we 30# don't wait at all. Defined in EAPIs 0 1 and 2.
46 need to have a "fake" dynamic lib in /usr/lib, 31epause() {
47 otherwise we run into linking problems. 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
48 See bug #4411 on http://bugs.gentoo.org/ for
49 more info. */
50GROUP ( /lib/libxxx )
51END_LDSCRIPT
52
53 dosed "s:libxxx:$1:" /usr/lib/$1
54
55 return 0
56} 33}
57 34
58# Simple function to draw a line consisting of '=' the same length as $* 35# @FUNCTION: ebeep
59# 36# @USAGE: [number of beeps]
60# <azarah@gentoo.org> (11 Nov 2002) 37# @DESCRIPTION:
61# 38# Issue the specified number of beeps (default of 5 beeps). Useful when
62draw_line() { 39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
42ebeep() {
63 local i=0 43 local n
64 local str_length="" 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
65 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
66 # Handle calls that do not have args, or wc not being installed ...
67 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
68 then
69 echo "==============================================================="
70 return 0
71 fi
72
73 # Get the length of $*
74 str_length="$(echo -n "$*" | wc -m)"
75
76 while [ "$i" -lt "${str_length}" ]
77 do
78 echo -n "=" 46 echo -ne "\a"
79 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
80 i=$((i + 1)) 48 echo -ne "\a"
49 sleep 1
81 done 50 done
51 fi
52}
82 53
83 echo 54else
84 55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 }
76fi
77
78# @FUNCTION: ecvs_clean
79# @USAGE: [list of dirs]
80# @DESCRIPTION:
81# Remove CVS directories recursiveley. Useful when a source tarball contains
82# internal CVS directories. Defaults to $PWD.
83ecvs_clean() {
84 [[ -z $* ]] && set -- .
85 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
86 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
87}
88
89# @FUNCTION: esvn_clean
90# @USAGE: [list of dirs]
91# @DESCRIPTION:
92# Remove .svn directories recursiveley. Useful when a source tarball contains
93# internal Subversion directories. Defaults to $PWD.
94esvn_clean() {
95 [[ -z $* ]] && set -- .
96 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
97}
98
99# @FUNCTION: eshopts_push
100# @USAGE: [options to `set` or `shopt`]
101# @DESCRIPTION:
102# Often times code will want to enable a shell option to change code behavior.
103# Since changing shell options can easily break other pieces of code (which
104# assume the default state), eshopts_push is used to (1) push the current shell
105# options onto a stack and (2) pass the specified arguments to set.
106#
107# If the first argument is '-s' or '-u', we assume you want to call `shopt`
108# rather than `set` as there are some options only available via that.
109#
110# A common example is to disable shell globbing so that special meaning/care
111# may be used with variables/arguments to custom functions. That would be:
112# @CODE
113# eshopts_push -o noglob
114# for x in ${foo} ; do
115# if ...some check... ; then
116# eshopts_pop
85 return 0 117# return 0
118# fi
119# done
120# eshopts_pop
121# @CODE
122eshopts_push() {
123 # have to assume __ESHOPTS_SAVE__ isn't screwed with
124 # as a `declare -a` here will reset its value
125 local i=${#__ESHOPTS_SAVE__[@]}
126 if [[ $1 == -[su] ]] ; then
127 __ESHOPTS_SAVE__[$i]=$(shopt -p)
128 [[ $# -eq 0 ]] && return 0
129 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
130 else
131 __ESHOPTS_SAVE__[$i]=$-
132 [[ $# -eq 0 ]] && return 0
133 set "$@" || die "eshopts_push: bad options to set: $*"
134 fi
86} 135}
87 136
88# Default directory where patches are located 137# @FUNCTION: eshopts_pop
138# @USAGE:
139# @DESCRIPTION:
140# Restore the shell options to the state saved with the corresponding
141# eshopts_push call. See that function for more details.
142eshopts_pop() {
143 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
144 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
145 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
146 local s=${__ESHOPTS_SAVE__[$i]}
147 unset __ESHOPTS_SAVE__[$i]
148 if [[ ${s} == "shopt -"* ]] ; then
149 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
150 else
151 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
152 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
153 fi
154}
155
156# @VARIABLE: EPATCH_SOURCE
157# @DESCRIPTION:
158# Default directory to search for patches.
89EPATCH_SOURCE="${WORKDIR}/patch" 159EPATCH_SOURCE="${WORKDIR}/patch"
90# Default extension for patches 160# @VARIABLE: EPATCH_SUFFIX
161# @DESCRIPTION:
162# Default extension for patches (do not prefix the period yourself).
91EPATCH_SUFFIX="patch.bz2" 163EPATCH_SUFFIX="patch.bz2"
164# @VARIABLE: EPATCH_OPTS
165# @DESCRIPTION:
92# Default options for patch 166# Default options for patch:
167# @CODE
93# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 168# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
94EPATCH_OPTS="-g0" 169# --no-backup-if-mismatch - do not leave .orig files behind
170# -E - automatically remove empty files
171# @CODE
172EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
173# @VARIABLE: EPATCH_EXCLUDE
174# @DESCRIPTION:
95# List of patches not to apply. Not this is only file names, 175# List of patches not to apply. Note this is only file names,
96# and not the full path .. 176# and not the full path. Globs accepted.
97EPATCH_EXCLUDE="" 177EPATCH_EXCLUDE=""
178# @VARIABLE: EPATCH_SINGLE_MSG
179# @DESCRIPTION:
98# Change the printed message for a single patch. 180# Change the printed message for a single patch.
99EPATCH_SINGLE_MSG="" 181EPATCH_SINGLE_MSG=""
100# Force applying bulk patches even if not following the style: 182# @VARIABLE: EPATCH_MULTI_MSG
101# 183# @DESCRIPTION:
102# ??_${ARCH}_foo.${EPATCH_SUFFIX} 184# Change the printed message for multiple patches.
103# 185EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
186# @VARIABLE: EPATCH_FORCE
187# @DESCRIPTION:
188# Only require patches to match EPATCH_SUFFIX rather than the extended
189# arch naming style.
104EPATCH_FORCE="no" 190EPATCH_FORCE="no"
105 191
106# This function is for bulk patching, or in theory for just one 192# @FUNCTION: epatch
107# or two patches. 193# @USAGE: [patches] [dirs of patches]
194# @DESCRIPTION:
195# epatch is designed to greatly simplify the application of patches. It can
196# process patch files directly, or directories of patches. The patches may be
197# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
198# the -p option as epatch will automatically attempt -p0 to -p5 until things
199# apply successfully.
108# 200#
109# It should work with .bz2, .gz, .zip and plain text patches. 201# If you do not specify any options, then epatch will default to the directory
110# Currently all patches should be the same format. 202# specified by EPATCH_SOURCE.
111# 203#
112# You do not have to specify '-p' option to patch, as it will 204# When processing directories, epatch will apply all patches that match:
113# try with -p0 to -p5 until it succeed, or fail at -p5. 205# @CODE
114# 206# if ${EPATCH_FORCE} != "yes"
115# Above EPATCH_* variables can be used to control various defaults,
116# bug they should be left as is to ensure an ebuild can rely on
117# them for.
118#
119# Patches are applied in current directory.
120#
121# Bulk Patches should preferibly have the form of:
122#
123# ??_${ARCH}_foo.${EPATCH_SUFFIX} 207# ??_${ARCH}_foo.${EPATCH_SUFFIX}
208# else
209# *.${EPATCH_SUFFIX}
210# @CODE
211# The leading ?? are typically numbers used to force consistent patch ordering.
212# The arch field is used to apply patches only for the host architecture with
213# the special value of "all" means apply for everyone. Note that using values
214# other than "all" is highly discouraged -- you should apply patches all the
215# time and let architecture details be detected at configure/compile time.
124# 216#
125# For example: 217# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
218# for patches to apply.
126# 219#
127# 01_all_misc-fix.patch.bz2 220# Refer to the other EPATCH_xxx variables for more customization of behavior.
128# 02_sparc_another-fix.patch.bz2
129#
130# This ensures that there are a set order, and you can have ARCH
131# specific patches.
132#
133# If you however give an argument to epatch(), it will treat it as a
134# single patch that need to be applied if its a file. If on the other
135# hand its a directory, it will set EPATCH_SOURCE to this.
136#
137# <azarah@gentoo.org> (10 Nov 2002)
138#
139epatch() { 221epatch() {
140 local PIPE_CMD="" 222 _epatch_draw_line() {
141 local STDERR_TARGET="${T}/$$.out" 223 # create a line of same length as input string
142 local PATCH_TARGET="${T}/$$.patch" 224 [[ -z $1 ]] && set "$(printf "%65s" '')"
143 local PATCH_SUFFIX="" 225 echo "${1//?/=}"
226 }
227
228 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
229
230 # Let the rest of the code process one user arg at a time --
231 # each arg may expand into multiple patches, and each arg may
232 # need to start off with the default global EPATCH_xxx values
233 if [[ $# -gt 1 ]] ; then
234 local m
235 for m in "$@" ; do
236 epatch "${m}"
237 done
238 return 0
239 fi
240
144 local SINGLE_PATCH="no" 241 local SINGLE_PATCH="no"
145 local x="" 242 # no args means process ${EPATCH_SOURCE}
243 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
146 244
147 if [ "$#" -gt 1 ] 245 if [[ -f $1 ]] ; then
148 then
149 eerror "Invalid arguments to epatch()"
150 die "Invalid arguments to epatch()"
151 fi
152
153 if [ -n "$1" -a -f "$1" ]
154 then
155 SINGLE_PATCH="yes" 246 SINGLE_PATCH="yes"
156 247 set -- "$1"
157 local EPATCH_SOURCE="$1" 248 # Use the suffix from the single patch (localize it); the code
249 # below will find the suffix for us
158 local EPATCH_SUFFIX="${1##*\.}" 250 local EPATCH_SUFFIX=$1
159 251
160 elif [ -n "$1" -a -d "$1" ] 252 elif [[ -d $1 ]] ; then
161 then 253 # Some people like to make dirs of patches w/out suffixes (vim)
162 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 254 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
163 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 255
256 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
257 # Re-use EPATCH_SOURCE as a search dir
258 epatch "${EPATCH_SOURCE}/$1"
259 return $?
260
261 else
262 # sanity check ... if it isn't a dir or file, wtf man ?
263 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
264 echo
265 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
266 eerror
267 eerror " ${EPATCH_SOURCE}"
268 eerror " ( ${EPATCH_SOURCE##*/} )"
269 echo
270 die "Cannot find \$EPATCH_SOURCE!"
271 fi
272
273 local PIPE_CMD
274 case ${EPATCH_SUFFIX##*\.} in
275 xz) PIPE_CMD="xz -dc" ;;
276 lzma) PIPE_CMD="lzma -dc" ;;
277 bz2) PIPE_CMD="bzip2 -dc" ;;
278 gz|Z|z) PIPE_CMD="gzip -dc" ;;
279 ZIP|zip) PIPE_CMD="unzip -p" ;;
280 *) ;;
281 esac
282
283 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
284
285 local x
286 for x in "$@" ; do
287 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
288 # didn't match anything, ignore continue on
289 [[ ! -f ${x} ]] && continue
290
291 local patchname=${x##*/}
292
293 # Apply single patches, or forced sets of patches, or
294 # patches with ARCH dependant names.
295 # ???_arch_foo.patch
296 # Else, skip this input altogether
297 local a=${patchname#*_} # strip the ???_
298 a=${a%%_*} # strip the _foo.patch
299 if ! [[ ${SINGLE_PATCH} == "yes" || \
300 ${EPATCH_FORCE} == "yes" || \
301 ${a} == all || \
302 ${a} == ${ARCH} ]]
164 then 303 then
165 local EPATCH_SOURCE="$1/*" 304 continue
305 fi
306
307 # Let people filter things dynamically
308 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
309 # let people use globs in the exclude
310 eshopts_push -o noglob
311
312 local ex
313 for ex in ${EPATCH_EXCLUDE} ; do
314 if [[ ${patchname} == ${ex} ]] ; then
315 eshopts_pop
316 continue 2
317 fi
318 done
319
320 eshopts_pop
321 fi
322
323 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
324 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
325 einfo "${EPATCH_SINGLE_MSG}"
326 else
327 einfo "Applying ${patchname} ..."
328 fi
166 else 329 else
167 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 330 einfo " ${patchname} ..."
331 fi
332
333 # most of the time, there will only be one run per unique name,
334 # but if there are more, make sure we get unique log filenames
335 local STDERR_TARGET="${T}/${patchname}.out"
336 if [[ -e ${STDERR_TARGET} ]] ; then
337 STDERR_TARGET="${T}/${patchname}-$$.out"
338 fi
339
340 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
341
342 # Decompress the patch if need be
343 local count=0
344 local PATCH_TARGET
345 if [[ -n ${PIPE_CMD} ]] ; then
346 PATCH_TARGET="${T}/$$.patch"
347 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
348
349 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
350 echo
351 eerror "Could not extract patch!"
352 #die "Could not extract patch!"
353 count=5
354 break
168 fi 355 fi
356 else
357 PATCH_TARGET=${x}
358 fi
359
360 # Check for absolute paths in patches. If sandbox is disabled,
361 # people could (accidently) patch files in the root filesystem.
362 # Or trigger other unpleasantries #237667. So disallow -p0 on
363 # such patches.
364 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
365 if [[ -n ${abs_paths} ]] ; then
366 count=1
367 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
368 fi
369 # Similar reason, but with relative paths.
370 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
371 if [[ -n ${rel_paths} ]] ; then
372 eqawarn "QA Notice: Your patch uses relative paths '../'."
373 eqawarn " In the future this will cause a failure."
374 eqawarn "${rel_paths}"
375 fi
376
377 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
378 while [[ ${count} -lt 5 ]] ; do
379 # Generate some useful debug info ...
380 (
381 _epatch_draw_line "***** ${patchname} *****"
382 echo
383 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
384 echo
385 _epatch_draw_line "***** ${patchname} *****"
386 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
387 ret=$?
388 echo
389 echo "patch program exited with status ${ret}"
390 exit ${ret}
391 ) >> "${STDERR_TARGET}"
392
393 if [ $? -eq 0 ] ; then
394 (
395 _epatch_draw_line "***** ${patchname} *****"
396 echo
397 echo "ACTUALLY APPLYING ${patchname} ..."
398 echo
399 _epatch_draw_line "***** ${patchname} *****"
400 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
401 ret=$?
402 echo
403 echo "patch program exited with status ${ret}"
404 exit ${ret}
405 ) >> "${STDERR_TARGET}"
406
407 if [ $? -ne 0 ] ; then
408 echo
409 eerror "A dry-run of patch command succeeded, but actually"
410 eerror "applying the patch failed!"
411 #die "Real world sux compared to the dreamworld!"
412 count=5
413 fi
414 break
415 fi
416
417 : $(( count++ ))
418 done
419
420 # if we had to decompress the patch, delete the temp one
421 if [[ -n ${PIPE_CMD} ]] ; then
422 rm -f "${PATCH_TARGET}"
423 fi
424
425 if [[ ${count} -ge 5 ]] ; then
426 echo
427 eerror "Failed Patch: ${patchname} !"
428 eerror " ( ${PATCH_TARGET} )"
429 eerror
430 eerror "Include in your bugreport the contents of:"
431 eerror
432 eerror " ${STDERR_TARGET}"
433 echo
434 die "Failed Patch: ${patchname}!"
435 fi
436
437 # if everything worked, delete the patch log
438 rm -f "${STDERR_TARGET}"
439 eend 0
440 done
441
442 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
443 : # everything worked
444}
445
446# @FUNCTION: epatch_user
447# @USAGE:
448# @DESCRIPTION:
449# Applies user-provided patches to the source tree. The patches are
450# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
451# of these three directories to exist will be the one to use, ignoring
452# any more general directories which might exist as well.
453#
454# User patches are intended for quick testing of patches without ebuild
455# modifications, as well as for permanent customizations a user might
456# desire. Obviously, there can be no official support for arbitrarily
457# patched ebuilds. So whenever a build log in a bug report mentions that
458# user patches were applied, the user should be asked to reproduce the
459# problem without these.
460#
461# Not all ebuilds do call this function, so placing patches in the
462# stated directory might or might not work, depending on the package and
463# the eclasses it inherits and uses. It is safe to call the function
464# repeatedly, so it is always possible to add a call at the ebuild
465# level. The first call is the time when the patches will be
466# applied.
467#
468# Ideally, this function should be called after gentoo-specific patches
469# have been applied, so that their code can be modified as well, but
470# before calls to e.g. eautoreconf, as the user patches might affect
471# autotool input files as well.
472epatch_user() {
473 [[ $# -ne 0 ]] && die "epatch_user takes no options"
474
475 # Allow multiple calls to this function; ignore all but the first
476 local applied="${T}/epatch_user.applied"
477 [[ -e ${applied} ]] && return 2
478
479 # don't clobber any EPATCH vars that the parent might want
480 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
481 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
482 EPATCH_SOURCE=${base}/${CTARGET}/${check}
483 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
484 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
485 if [[ -d ${EPATCH_SOURCE} ]] ; then
486 EPATCH_SOURCE=${EPATCH_SOURCE} \
487 EPATCH_SUFFIX="patch" \
488 EPATCH_FORCE="yes" \
489 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
490 epatch
491 echo "${EPATCH_SOURCE}" > "${applied}"
492 return 0
493 fi
494 done
495 echo "none" > "${applied}"
496 return 1
497}
498
499# @FUNCTION: emktemp
500# @USAGE: [temp dir]
501# @DESCRIPTION:
502# Cheap replacement for when debianutils (and thus mktemp)
503# does not exist on the users system.
504emktemp() {
505 local exe="touch"
506 [[ $1 == -d ]] && exe="mkdir" && shift
507 local topdir=$1
508
509 if [[ -z ${topdir} ]] ; then
510 [[ -z ${T} ]] \
511 && topdir="/tmp" \
512 || topdir=${T}
513 fi
514
515 if ! type -P mktemp > /dev/null ; then
516 # system lacks `mktemp` so we have to fake it
517 local tmp=/
518 while [[ -e ${tmp} ]] ; do
519 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
520 done
521 ${exe} "${tmp}" || ${exe} -p "${tmp}"
522 echo "${tmp}"
169 else 523 else
170 if [ ! -d ${EPATCH_SOURCE} ] 524 # the args here will give slightly wierd names on BSD,
171 then 525 # but should produce a usable file on all userlands
172 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 526 if [[ ${exe} == "touch" ]] ; then
173 then 527 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
174 EPATCH_SOURCE="$1" 528 else
529 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
175 fi 530 fi
176
177 echo
178 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
179 eerror
180 eerror " ${EPATCH_SOURCE}"
181 echo
182 die "Cannot find \$EPATCH_SOURCE!"
183 fi 531 fi
532}
184 533
185 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}" 534# @FUNCTION: egetent
186 fi 535# @USAGE: <database> <key>
187 536# @MAINTAINER:
188 case ${EPATCH_SUFFIX##*\.} in 537# base-system@gentoo.org (Linux)
189 bz2) 538# Joe Jezak <josejx@gmail.com> (OS X)
190 PIPE_CMD="bzip2 -dc" 539# usata@gentoo.org (OS X)
191 PATCH_SUFFIX="bz2" 540# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
541# @DESCRIPTION:
542# Small wrapper for getent (Linux),
543# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
544# and pw (FreeBSD) used in enewuser()/enewgroup()
545egetent() {
546 case ${CHOST} in
547 *-darwin[678])
548 case "$2" in
549 *[!0-9]*) # Non numeric
550 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2\$/) {print \$0;exit;} }"
192 ;; 551 ;;
193 gz|Z|z) 552 *) # Numeric
194 PIPE_CMD="gzip -dc" 553 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
195 PATCH_SUFFIX="gz"
196 ;; 554 ;;
197 ZIP|zip) 555 esac
198 PIPE_CMD="unzip -p" 556 ;;
199 PATCH_SUFFIX="zip" 557 *-darwin*)
558 local mytype=$1
559 [[ "passwd" == $mytype ]] && mytype="Users"
560 [[ "group" == $mytype ]] && mytype="Groups"
561 case "$2" in
562 *[!0-9]*) # Non numeric
563 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
200 ;; 564 ;;
201 *) 565 *) # Numeric
202 PIPE_CMD="cat" 566 local mykey="UniqueID"
203 PATCH_SUFFIX="patch" 567 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
568 dscl . -search /$mytype $mykey $2 2>/dev/null
204 ;; 569 ;;
570 esac
571 ;;
572 *-freebsd*|*-dragonfly*)
573 local opts action="user"
574 [[ $1 == "passwd" ]] || action="group"
575
576 # lookup by uid/gid
577 if [[ $2 == [[:digit:]]* ]] ; then
578 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
579 fi
580
581 pw show ${action} ${opts} "$2" -q
582 ;;
583 *-netbsd*|*-openbsd*)
584 grep "$2:\*:" /etc/$1
585 ;;
586 *)
587 type -p nscd >& /dev/null && nscd -i "$1"
588 getent "$1" "$2"
589 ;;
205 esac 590 esac
206
207 if [ "${SINGLE_PATCH}" = "no" ]
208 then
209 einfo "Applying various patches (bugfixes/updates)..."
210 fi
211 for x in ${EPATCH_SOURCE}
212 do
213 # New ARCH dependant patch naming scheme...
214 #
215 # ???_arch_foo.patch
216 #
217 if [ -f ${x} ] && \
218 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
219 [ "${EPATCH_FORCE}" = "yes" ])
220 then
221 local count=0
222 local popts="${EPATCH_OPTS}"
223
224 if [ -n "${EPATCH_EXCLUDE}" ]
225 then
226 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
227 then
228 continue
229 fi
230 fi
231
232 if [ "${SINGLE_PATCH}" = "yes" ]
233 then
234 if [ -n "${EPATCH_SINGLE_MSG}" ]
235 then
236 einfo "${EPATCH_SINGLE_MSG}"
237 else
238 einfo "Applying ${x##*/}..."
239 fi
240 else
241 einfo " ${x##*/}..."
242 fi
243
244 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
245 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
246
247 # Allow for prefix to differ ... im lazy, so shoot me :/
248 while [ "${count}" -lt 5 ]
249 do
250 # Generate some useful debug info ...
251 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
252 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
253
254 if [ "${PATCH_SUFFIX}" != "patch" ]
255 then
256 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
257 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
258 else
259 PATCH_TARGET="${x}"
260 fi
261
262 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
263 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
264
265 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
266 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
267
268 if [ "${PATCH_SUFFIX}" != "patch" ]
269 then
270 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
271 then
272 echo
273 eerror "Could not extract patch!"
274 #die "Could not extract patch!"
275 count=5
276 break
277 fi
278 fi
279
280 if (cat ${PATCH_TARGET} | patch ${popts} --dry-run -f -p${count}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
281 then
282 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
283 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
284 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
285 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
286 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
287
288 cat ${PATCH_TARGET} | patch ${popts} -p${count} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
289
290 if [ "$?" -ne 0 ]
291 then
292 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
293 echo
294 eerror "A dry-run of patch command succeeded, but actually"
295 eerror "applying the patch failed!"
296 #die "Real world sux compared to the dreamworld!"
297 count=5
298 fi
299
300 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
301
302 break
303 fi
304
305 count=$((count + 1))
306 done
307
308 if [ "${PATCH_SUFFIX}" != "patch" ]
309 then
310 rm -f ${PATCH_TARGET}
311 fi
312
313 if [ "${count}" -eq 5 ]
314 then
315 echo
316 eerror "Failed Patch: ${x##*/}!"
317 eerror
318 eerror "Include in your bugreport the contents of:"
319 eerror
320 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
321 echo
322 die "Failed Patch: ${x##*/}!"
323 fi
324
325 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
326
327 eend 0
328 fi
329 done
330 if [ "${SINGLE_PATCH}" = "no" ]
331 then
332 einfo "Done with patching"
333 fi
334} 591}
335 592
336# This function return true if we are using the NPTL pthreads 593# @FUNCTION: enewuser
337# implementation. 594# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
338# 595# @DESCRIPTION:
339# <azarah@gentoo.org> (06 March 2003) 596# Same as enewgroup, you are not required to understand how to properly add
340# 597# a user to the system. The only required parameter is the username.
341 598# Default uid is (pass -1 for this) next available, default shell is
342have_NPTL() { 599# /bin/false, default homedir is /dev/null, there are no default groups,
343 600# and default params sets the comment as 'added by portage for ${PN}'.
344 cat > ${T}/test-nptl.c <<-"END"
345 #define _XOPEN_SOURCE
346 #include <unistd.h>
347 #include <stdio.h>
348
349 int main()
350 {
351 char buf[255];
352 char *str = buf;
353
354 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
355 if (NULL != str) {
356 printf("%s\n", str);
357 if (NULL != strstr(str, "NPTL"))
358 return 0;
359 }
360
361 return 1;
362 }
363 END
364
365 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ... "
366 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
367 then
368 echo "yes"
369 einfon "Checking what PTHREADS implementation we have ... "
370 if ${T}/nptl
371 then
372 return 0
373 else
374 return 1
375 fi
376 else
377 echo "no"
378 fi
379
380 return 1
381}
382
383# This function check how many cpu's are present, and then set
384# -j in MAKEOPTS accordingly.
385#
386# Thanks to nall <nall@gentoo.org> for this.
387#
388get_number_of_jobs() {
389 local jobs=0
390
391 if [ ! -r /proc/cpuinfo ]
392 then
393 return 1
394 fi
395
396 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
397 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
398 then
399 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
400 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
401 ADMINPARAM="${ADMINPARAM/-j}"
402 fi
403
404 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
405
406 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
407 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
408 then
409 # these archs will always have "[Pp]rocessor"
410 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
411
412 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
413 then
414 # sparc always has "ncpus active"
415 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
416
417 elif [ "${ARCH}" = "alpha" ]
418 then
419 # alpha has "cpus active", but only when compiled with SMP
420 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
421 then
422 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
423 else
424 jobs=2
425 fi
426
427 elif [ "${ARCH}" = "ppc" ]
428 then
429 # ppc has "processor", but only when compiled with SMP
430 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
431 then
432 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
433 else
434 jobs=2
435 fi
436 else
437 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
438 die "Unknown ARCH -- ${ARCH}!"
439 fi
440
441 # Make sure the number is valid ...
442 if [ "${jobs}" -lt 1 ]
443 then
444 jobs=1
445 fi
446
447 if [ -n "${ADMINPARAM}" ]
448 then
449 if [ "${jobs}" -gt "${ADMINPARAM}" ]
450 then
451 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
452 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
453 else
454 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
455 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
456 fi
457 fi
458}
459
460# Cheap replacement for when debianutils (and thus mktemp)
461# do not exist on the users system
462# vapier@gentoo.org
463#
464# Takes just 1 parameter (the directory to create tmpfile in)
465mymktemp() {
466 local topdir="$1"
467
468 [ -z "${topdir}" ] && topdir=/tmp
469 if [ "`which mktemp 2>/dev/null`" ]
470 then
471 mktemp -p ${topdir}
472 else
473 local tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}"
474 touch ${tmp}
475 echo ${tmp}
476 fi
477}
478
479# Simplify/standardize adding users to the system
480# vapier@gentoo.org
481#
482# enewuser(username, uid, shell, homedir, groups, extra options)
483#
484# Default values if you do not specify any:
485# username: REQUIRED !
486# uid: next available (see useradd(8))
487# note: pass -1 to get default behavior
488# shell: /bin/false
489# homedir: /dev/null
490# groups: none
491# extra: comment of 'added by portage for ${PN}'
492enewuser() { 601enewuser() {
602 case ${EBUILD_PHASE} in
603 unpack|compile|test|install)
604 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
605 eerror "Package fails at QA and at life. Please file a bug."
606 die "Bad package! enewuser is only for use in pkg_* functions!"
607 esac
608
493 # get the username 609 # get the username
494 local euser="$1"; shift 610 local euser=$1; shift
495 if [ -z "${euser}" ] 611 if [[ -z ${euser} ]] ; then
496 then
497 eerror "No username specified !" 612 eerror "No username specified !"
498 die "Cannot call enewuser without a username" 613 die "Cannot call enewuser without a username"
499 fi 614 fi
500 615
501 # setup a file for testing usernames/groups
502 local tmpfile="`mymktemp ${T}`"
503 chown ${euser} ${tmpfile} >& /dev/null
504 local realuser="`ls -l ${tmpfile} | awk '{print $3}'`"
505
506 # see if user already exists 616 # lets see if the username already exists
507 if [ "${euser}" == "${realuser}" ] 617 if [[ -n $(egetent passwd "${euser}") ]] ; then
508 then
509 return 0 618 return 0
510 fi 619 fi
511 einfo "Adding user '${euser}' to your system ..." 620 einfo "Adding user '${euser}' to your system ..."
512 621
513 # options to pass to useradd 622 # options to pass to useradd
514 local opts= 623 local opts=
515 624
516 # handle uid 625 # handle uid
517 local euid="$1"; shift 626 local euid=$1; shift
518 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ] 627 if [[ -n ${euid} && ${euid} != -1 ]] ; then
519 then
520 if [ "${euid}" -gt 0 ] 628 if [[ ${euid} -gt 0 ]] ; then
521 then 629 if [[ -n $(egetent passwd ${euid}) ]] ; then
522 opts="${opts} -u ${euid}" 630 euid="next"
631 fi
523 else 632 else
524 eerror "Userid given but is not greater than 0 !" 633 eerror "Userid given but is not greater than 0 !"
525 die "${euid} is not a valid UID" 634 die "${euid} is not a valid UID"
526 fi 635 fi
527 else 636 else
528 euid="next available" 637 euid="next"
529 fi 638 fi
639 if [[ ${euid} == "next" ]] ; then
640 for ((euid = 101; euid <= 999; euid++)); do
641 [[ -z $(egetent passwd ${euid}) ]] && break
642 done
643 fi
644 opts="${opts} -u ${euid}"
530 einfo " - Userid: ${euid}" 645 einfo " - Userid: ${euid}"
531 646
532 # handle shell 647 # handle shell
533 local eshell="$1"; shift 648 local eshell=$1; shift
534 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ] 649 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
535 then 650 if [[ ! -e ${ROOT}${eshell} ]] ; then
536 if [ ! -e "${eshell}" ]
537 then
538 eerror "A shell was specified but it does not exist !" 651 eerror "A shell was specified but it does not exist !"
539 die "${eshell} does not exist" 652 die "${eshell} does not exist in ${ROOT}"
653 fi
654 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
655 eerror "Do not specify ${eshell} yourself, use -1"
656 die "Pass '-1' as the shell parameter"
540 fi 657 fi
541 else 658 else
659 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
660 [[ -x ${ROOT}${shell} ]] && break
661 done
662
663 if [[ ${shell} == "/dev/null" ]] ; then
664 eerror "Unable to identify the shell to use, proceeding with userland default."
665 case ${USERLAND} in
542 eshell="/bin/false" 666 GNU) shell="/bin/false" ;;
667 BSD) shell="/sbin/nologin" ;;
668 Darwin) shell="/usr/sbin/nologin" ;;
669 *) die "Unable to identify the default shell for userland ${USERLAND}"
670 esac
671 fi
672
673 eshell=${shell}
543 fi 674 fi
544 einfo " - Shell: ${eshell}" 675 einfo " - Shell: ${eshell}"
545 opts="${opts} -s ${eshell}" 676 opts="${opts} -s ${eshell}"
546 677
547 # handle homedir 678 # handle homedir
548 local ehome="$1"; shift 679 local ehome=$1; shift
549 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ] 680 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
550 then
551 ehome="/dev/null" 681 ehome="/dev/null"
552 fi 682 fi
553 einfo " - Home: ${ehome}" 683 einfo " - Home: ${ehome}"
554 opts="${opts} -d ${ehome}" 684 opts="${opts} -d ${ehome}"
555 685
556 # handle groups 686 # handle groups
557 local egroups="$1"; shift 687 local egroups=$1; shift
558 if [ ! -z "${egroups}" ] 688 if [[ ! -z ${egroups} ]] ; then
559 then
560 local realgroup=
561 local oldifs="${IFS}" 689 local oldifs=${IFS}
690 local defgroup="" exgroups=""
691
562 export IFS="," 692 export IFS=","
563 for g in ${egroups} 693 for g in ${egroups} ; do
564 do 694 export IFS=${oldifs}
565 chgrp ${g} ${tmpfile} >& /dev/null 695 if [[ -z $(egetent group "${g}") ]] ; then
566 realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
567 if [ "${g}" != "${realgroup}" ]
568 then
569 eerror "You must add ${g} to the system first" 696 eerror "You must add group ${g} to the system first"
570 die "${g} is not a valid GID" 697 die "${g} is not a valid GID"
571 fi 698 fi
699 if [[ -z ${defgroup} ]] ; then
700 defgroup=${g}
701 else
702 exgroups="${exgroups},${g}"
703 fi
704 export IFS=","
572 done 705 done
573 export IFS="${oldifs}" 706 export IFS=${oldifs}
707
574 opts="${opts} -g ${egroups}" 708 opts="${opts} -g ${defgroup}"
709 if [[ ! -z ${exgroups} ]] ; then
710 opts="${opts} -G ${exgroups:1}"
711 fi
575 else 712 else
576 egroups="(none)" 713 egroups="(none)"
577 fi 714 fi
578 einfo " - Groups: ${egroups}" 715 einfo " - Groups: ${egroups}"
579 716
580 # handle extra and add the user 717 # handle extra and add the user
581 local eextra="$@"
582 local oldsandbox="${SANDBOX_ON}" 718 local oldsandbox=${SANDBOX_ON}
583 export SANDBOX_ON="0" 719 export SANDBOX_ON="0"
584 if [ -z "${eextra}" ] 720 case ${CHOST} in
585 then 721 *-darwin*)
586 useradd ${opts} ${euser} \ 722 ### Make the user
723 if [[ -z $@ ]] ; then
724 dscl . create /users/${euser} uid ${euid}
725 dscl . create /users/${euser} shell ${eshell}
726 dscl . create /users/${euser} home ${ehome}
727 dscl . create /users/${euser} realname "added by portage for ${PN}"
728 ### Add the user to the groups specified
729 local oldifs=${IFS}
730 export IFS=","
731 for g in ${egroups} ; do
732 dscl . merge /groups/${g} users ${euser}
733 done
734 export IFS=${oldifs}
735 else
736 einfo "Extra options are not supported on Darwin yet"
737 einfo "Please report the ebuild along with the info below"
738 einfo "eextra: $@"
739 die "Required function missing"
740 fi
741 ;;
742 *-freebsd*|*-dragonfly*)
743 if [[ -z $@ ]] ; then
744 pw useradd ${euser} ${opts} \
587 -c "added by portage for ${PN}" \ 745 -c "added by portage for ${PN}" \
746 die "enewuser failed"
747 else
748 einfo " - Extra: $@"
749 pw useradd ${euser} ${opts} \
750 "$@" || die "enewuser failed"
751 fi
752 ;;
753
754 *-netbsd*)
755 if [[ -z $@ ]] ; then
756 useradd ${opts} ${euser} || die "enewuser failed"
757 else
758 einfo " - Extra: $@"
759 useradd ${opts} ${euser} "$@" || die "enewuser failed"
760 fi
761 ;;
762
763 *-openbsd*)
764 if [[ -z $@ ]] ; then
765 useradd -u ${euid} -s ${eshell} \
766 -d ${ehome} -c "Added by portage for ${PN}" \
767 -g ${egroups} ${euser} || die "enewuser failed"
768 else
769 einfo " - Extra: $@"
770 useradd -u ${euid} -s ${eshell} \
771 -d ${ehome} -c "Added by portage for ${PN}" \
772 -g ${egroups} ${euser} "$@" || die "enewuser failed"
773 fi
774 ;;
775
776 *)
777 if [[ -z $@ ]] ; then
778 useradd -r ${opts} \
779 -c "added by portage for ${PN}" \
780 ${euser} \
588 || die "enewuser failed" 781 || die "enewuser failed"
589 else 782 else
590 einfo " - Extra: ${eextra}" 783 einfo " - Extra: $@"
591 useradd ${opts} ${euser} ${eextra} \ 784 useradd -r ${opts} "$@" \
785 ${euser} \
592 || die "enewuser failed" 786 || die "enewuser failed"
593 fi 787 fi
788 ;;
789 esac
790
791 if [[ ! -e ${ROOT}/${ehome} ]] ; then
792 einfo " - Creating ${ehome} in ${ROOT}"
793 mkdir -p "${ROOT}/${ehome}"
794 chown ${euser} "${ROOT}/${ehome}"
795 chmod 755 "${ROOT}/${ehome}"
796 fi
797
594 export SANDBOX_ON="${oldsandbox}" 798 export SANDBOX_ON=${oldsandbox}
595
596 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
597 then
598 einfo " - Creating ${ehome} in ${D}"
599 dodir ${ehome}
600 fowners ${euser} ${ehome}
601 fperms 755 ${ehome}
602 fi
603} 799}
604 800
605# Simplify/standardize adding groups to the system 801# @FUNCTION: enewgroup
606# vapier@gentoo.org 802# @USAGE: <group> [gid]
607# 803# @DESCRIPTION:
608# enewgroup(group, gid) 804# This function does not require you to understand how to properly add a
609# 805# group to the system. Just give it a group name to add and enewgroup will
610# Default values if you do not specify any: 806# do the rest. You may specify the gid for the group or allow the group to
611# groupname: REQUIRED ! 807# allocate the next available one.
612# gid: next available (see groupadd(8))
613# extra: none
614enewgroup() { 808enewgroup() {
809 case ${EBUILD_PHASE} in
810 unpack|compile|test|install)
811 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
812 eerror "Package fails at QA and at life. Please file a bug."
813 die "Bad package! enewgroup is only for use in pkg_* functions!"
814 esac
815
615 # get the group 816 # get the group
616 local egroup="$1"; shift 817 local egroup="$1"; shift
617 if [ -z "${egroup}" ] 818 if [ -z "${egroup}" ]
618 then 819 then
619 eerror "No group specified !" 820 eerror "No group specified !"
620 die "Cannot call enewgroup without a group" 821 die "Cannot call enewgroup without a group"
621 fi 822 fi
622 823
623 # setup a file for testing groupname
624 local tmpfile="`mymktemp ${T}`"
625 chgrp ${egroup} ${tmpfile} >& /dev/null
626 local realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
627
628 # see if group already exists 824 # see if group already exists
629 if [ "${egroup}" == "${realgroup}" ] 825 if [[ -n $(egetent group "${egroup}") ]]; then
630 then
631 return 0 826 return 0
632 fi 827 fi
633 einfo "Adding group '${egroup}' to your system ..." 828 einfo "Adding group '${egroup}' to your system ..."
634 829
635 # options to pass to useradd 830 # options to pass to useradd
639 local egid="$1"; shift 834 local egid="$1"; shift
640 if [ ! -z "${egid}" ] 835 if [ ! -z "${egid}" ]
641 then 836 then
642 if [ "${egid}" -gt 0 ] 837 if [ "${egid}" -gt 0 ]
643 then 838 then
839 if [ -z "`egetent group ${egid}`" ]
840 then
841 if [[ "${CHOST}" == *-darwin* ]]; then
842 opts="${opts} ${egid}"
843 else
644 opts="${opts} -g ${egid}" 844 opts="${opts} -g ${egid}"
845 fi
846 else
847 egid="next available; requested gid taken"
848 fi
645 else 849 else
646 eerror "Groupid given but is not greater than 0 !" 850 eerror "Groupid given but is not greater than 0 !"
647 die "${egid} is not a valid GID" 851 die "${egid} is not a valid GID"
648 fi 852 fi
649 else 853 else
656 opts="${opts} ${eextra}" 860 opts="${opts} ${eextra}"
657 861
658 # add the group 862 # add the group
659 local oldsandbox="${SANDBOX_ON}" 863 local oldsandbox="${SANDBOX_ON}"
660 export SANDBOX_ON="0" 864 export SANDBOX_ON="0"
865 case ${CHOST} in
866 *-darwin*)
867 if [ ! -z "${eextra}" ];
868 then
869 einfo "Extra options are not supported on Darwin/OS X yet"
870 einfo "Please report the ebuild along with the info below"
871 einfo "eextra: ${eextra}"
872 die "Required function missing"
873 fi
874
875 # If we need the next available
876 case ${egid} in
877 *[!0-9]*) # Non numeric
878 for ((egid = 101; egid <= 999; egid++)); do
879 [[ -z $(egetent group ${egid}) ]] && break
880 done
881 esac
882 dscl . create /groups/${egroup} gid ${egid}
883 dscl . create /groups/${egroup} passwd '*'
884 ;;
885
886 *-freebsd*|*-dragonfly*)
887 case ${egid} in
888 *[!0-9]*) # Non numeric
889 for ((egid = 101; egid <= 999; egid++)); do
890 [[ -z $(egetent group ${egid}) ]] && break
891 done
892 esac
893 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
894 ;;
895
896 *-netbsd*)
897 case ${egid} in
898 *[!0-9]*) # Non numeric
899 for ((egid = 101; egid <= 999; egid++)); do
900 [[ -z $(egetent group ${egid}) ]] && break
901 done
902 esac
903 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
904 ;;
905
906 *)
907 # We specify -r so that we get a GID in the system range from login.defs
661 groupadd ${opts} ${egroup} || die "enewgroup failed" 908 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
909 ;;
910 esac
662 export SANDBOX_ON="${oldsandbox}" 911 export SANDBOX_ON="${oldsandbox}"
663} 912}
664 913
665# Simple script to replace 'dos2unix' binaries 914# @FUNCTION: edos2unix
666# vapier@gentoo.org 915# @USAGE: <file> [more files ...]
667# 916# @DESCRIPTION:
668# edos2unix(file, <more files>...) 917# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
918# to remove all of these text utilities from DEPEND variables because this
919# is a script based solution. Just give it a list of files to convert and
920# they will all be changed from the DOS CRLF format to the UNIX LF format.
669edos2unix() { 921edos2unix() {
670 for f in "$@" 922 [[ $# -eq 0 ]] && return 0
671 do 923 sed -i 's/\r$//' -- "$@" || die
672 cp "${f}" ${T}/edos2unix
673 sed 's/\r$//' ${T}/edos2unix > "${f}"
674 done
675} 924}
676 925
677# Make a desktop file ! 926# Make a desktop file !
678# Great for making those icons in kde/gnome startmenu ! 927# Great for making those icons in kde/gnome startmenu !
679# Amaze your friends ! Get the women ! Join today ! 928# Amaze your friends ! Get the women ! Join today !
680# gnome2 /usr/share/applications
681# gnome1 /usr/share/gnome/apps/
682# KDE ${KDEDIR}/share/applnk /usr/share/applnk
683# 929#
684# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 930# make_desktop_entry(<command>, [name], [icon], [type], [fields])
685# 931#
686# binary: what binary does the app run with ? 932# binary: what command does the app run with ?
687# name: the name that will show up in the menu 933# name: the name that will show up in the menu
688# icon: give your little like a pretty little icon ... 934# icon: give your little like a pretty little icon ...
689# this can be relative (to /usr/share/pixmaps) or 935# this can be relative (to /usr/share/pixmaps) or
690# a full path to an icon 936# a full path to an icon
691# type: what kind of application is this ? for categories: 937# type: what kind of application is this ? for categories:
692# http://www.freedesktop.org/standards/menu/draft/menu-spec/menu-spec.html 938# http://standards.freedesktop.org/menu-spec/latest/apa.html
693# path: if your app needs to startup in a specific dir 939# fields: extra fields to append to the desktop file; a printf string
694make_desktop_entry() { 940make_desktop_entry() {
695 [ -z "$1" ] && eerror "You must specify the executable" && return 1 941 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
696 942
697 local exec="${1}" 943 local exec=${1}
698 local name="${2:-${PN}}" 944 local name=${2:-${PN}}
699 local icon="${3:-${PN}.png}" 945 local icon=${3:-${PN}}
700 local type="${4}" 946 local type=${4}
701 local path="${5:-${GAMES_PREFIX}}" 947 local fields=${5}
948
702 if [ -z "${type}" ] 949 if [[ -z ${type} ]] ; then
703 then 950 local catmaj=${CATEGORY%%-*}
704 case ${CATEGORY} in 951 local catmin=${CATEGORY##*-}
705 "app-emulation") 952 case ${catmaj} in
706 type=Emulator 953 app)
954 case ${catmin} in
955 accessibility) type=Accessibility;;
956 admin) type=System;;
957 antivirus) type=System;;
958 arch) type=Archiving;;
959 backup) type=Archiving;;
960 cdr) type=DiscBurning;;
961 dicts) type=Dictionary;;
962 doc) type=Documentation;;
963 editors) type=TextEditor;;
964 emacs) type=TextEditor;;
965 emulation) type=Emulator;;
966 laptop) type=HardwareSettings;;
967 office) type=Office;;
968 pda) type=PDA;;
969 vim) type=TextEditor;;
970 xemacs) type=TextEditor;;
971 esac
707 ;; 972 ;;
708 "games-"*) 973
709 type=Game 974 dev)
975 type="Development"
710 ;; 976 ;;
711 "net-"*) 977
712 type=Network; 978 games)
979 case ${catmin} in
980 action|fps) type=ActionGame;;
981 arcade) type=ArcadeGame;;
982 board) type=BoardGame;;
983 emulation) type=Emulator;;
984 kids) type=KidsGame;;
985 puzzle) type=LogicGame;;
986 roguelike) type=RolePlaying;;
987 rpg) type=RolePlaying;;
988 simulation) type=Simulation;;
989 sports) type=SportsGame;;
990 strategy) type=StrategyGame;;
991 esac
992 type="Game;${type}"
713 ;; 993 ;;
994
995 gnome)
996 type="Gnome;GTK"
997 ;;
998
999 kde)
1000 type="KDE;Qt"
1001 ;;
1002
1003 mail)
1004 type="Network;Email"
1005 ;;
1006
1007 media)
1008 case ${catmin} in
1009 gfx)
1010 type=Graphics
1011 ;;
1012 *)
1013 case ${catmin} in
1014 radio) type=Tuner;;
1015 sound) type=Audio;;
1016 tv) type=TV;;
1017 video) type=Video;;
1018 esac
1019 type="AudioVideo;${type}"
1020 ;;
1021 esac
1022 ;;
1023
1024 net)
1025 case ${catmin} in
1026 dialup) type=Dialup;;
1027 ftp) type=FileTransfer;;
1028 im) type=InstantMessaging;;
1029 irc) type=IRCClient;;
1030 mail) type=Email;;
1031 news) type=News;;
1032 nntp) type=News;;
1033 p2p) type=FileTransfer;;
1034 voip) type=Telephony;;
1035 esac
1036 type="Network;${type}"
1037 ;;
1038
1039 sci)
1040 case ${catmin} in
1041 astro*) type=Astronomy;;
1042 bio*) type=Biology;;
1043 calc*) type=Calculator;;
1044 chem*) type=Chemistry;;
1045 elec*) type=Electronics;;
1046 geo*) type=Geology;;
1047 math*) type=Math;;
1048 physics) type=Physics;;
1049 visual*) type=DataVisualization;;
1050 esac
1051 type="Education;Science;${type}"
1052 ;;
1053
1054 sys)
1055 type="System"
1056 ;;
1057
1058 www)
1059 case ${catmin} in
1060 client) type=WebBrowser;;
1061 esac
1062 type="Network;${type}"
1063 ;;
1064
714 *) 1065 *)
715 type= 1066 type=
716 ;; 1067 ;;
717 esac 1068 esac
718 fi 1069 fi
719 local desktop="${T}/${exec}.desktop" 1070 if [ "${SLOT}" == "0" ] ; then
1071 local desktop_name="${PN}"
1072 else
1073 local desktop_name="${PN}-${SLOT}"
1074 fi
1075 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
1076 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
720 1077
1078 # Don't append another ";" when a valid category value is provided.
1079 type=${type%;}${type:+;}
1080
1081 eshopts_push -s extglob
1082 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1083 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1084 ewarn "allowed in .desktop files if the value is not an absolute path."
1085 icon=${icon%.@(xpm|png|svg)}
1086 fi
1087 eshopts_pop
1088
1089 cat <<-EOF > "${desktop}"
721echo "[Desktop Entry] 1090 [Desktop Entry]
722Encoding=UTF-8
723Version=0.9.2
724Name=${name} 1091 Name=${name}
725Type=Application 1092 Type=Application
726Comment=${DESCRIPTION} 1093 Comment=${DESCRIPTION}
727Exec=${exec} 1094 Exec=${exec}
728Path=${path} 1095 TryExec=${exec%% *}
729Icon=${icon} 1096 Icon=${icon}
730Categories=Application;${type};" > ${desktop} 1097 Categories=${type}
1098 EOF
731 1099
732 if [ -d "/usr/share/applications" ] 1100 if [[ ${fields:-=} != *=* ]] ; then
733 then 1101 # 5th arg used to be value to Path=
1102 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1103 fields="Path=${fields}"
1104 fi
1105 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
1106
1107 (
1108 # wrap the env here so that the 'insinto' call
1109 # doesn't corrupt the env of the caller
734 insinto /usr/share/applications 1110 insinto /usr/share/applications
735 doins ${desktop} 1111 doins "${desktop}"
736 fi 1112 ) || die "installing desktop file failed"
1113}
737 1114
738 #if [ -d "/usr/share/gnome/apps" ] 1115# @FUNCTION: validate_desktop_entries
739 #then 1116# @USAGE: [directories]
740 # insinto /usr/share/gnome/apps/Games 1117# @MAINTAINER:
741 # doins ${desktop} 1118# Carsten Lohrke <carlo@gentoo.org>
742 #fi 1119# @DESCRIPTION:
743 1120# Validate desktop entries using desktop-file-utils
744 #if [ ! -z "`ls /usr/kde/* 2>/dev/null`" ] 1121validate_desktop_entries() {
745 #then 1122 if [[ -x /usr/bin/desktop-file-validate ]] ; then
746 # for ver in /usr/kde/* 1123 einfo "Checking desktop entry validity"
747 # do 1124 local directories=""
748 # insinto ${ver}/share/applnk/Games 1125 for d in /usr/share/applications $@ ; do
749 # doins ${desktop} 1126 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
750 # done 1127 done
751 #fi 1128 if [[ -n ${directories} ]] ; then
752 1129 for FILE in $(find ${directories} -name "*\.desktop" \
753 if [ -d "/usr/share/applnk" ] 1130 -not -path '*.hidden*' | sort -u 2>/dev/null)
754 then
755 insinto /usr/share/applnk/${type}
756 doins ${desktop}
757 fi
758
759 return 0
760}
761
762# new convenience patch wrapper function to eventually replace epatch(),
763# $PATCHES, $PATCHES1, src_unpack:patch, src_unpack:autopatch and
764# /usr/bin/patch
765# Features:
766# - bulk patch handling similar to epatch()'s
767# - automatic patch level detection like epatch()'s
768# - automatic patch uncompression like epatch()'s
769# - doesn't have the --dry-run overhead of epatch() - inspects patchfiles
770# manually instead
771# - once I decide it's production-ready, it'll be called from base_src_unpack
772# to handle $PATCHES to avoid defining src_unpack just to use xpatch
773
774# accepts zero or more parameters specifying patchfiles and/or patchdirs
775
776# known issues:
777# - only supports unified style patches (does anyone _really_ use anything
778# else?)
779# - because it doesn't use --dry-run there is a risk of it failing
780# to find the files to patch, ie detect the patchlevel, properly. It doesn't use
781# any of the backup heuristics that patch employs to discover a filename.
782# however, this isn't dangerous because if it works for the developer who's
783# writing the ebuild, it'll always work for the users, and if it doesn't,
784# then we'll fix it :-)
785# - no support as yet for patches applying outside $S (and not directly in $WORKDIR).
786xpatch() {
787
788 debug-print-function ${FUNCNAME} $*
789
790 local list=
791 local list2=
792 declare -i plevel
793
794 # parse patch sources
795 for x in $*
796 do
797 debug-print "${FUNCNAME}: parsing parameter ${x}"
798 if [ -f "${x}" ]
799 then
800 list="${list} ${x}"
801 elif [ -d "${x}" ]
802 then
803 # handles patchdirs like epatch() for now: no recursion.
804 # patches are sorted by filename, so with an xy_foo naming scheme you'll get the right order.
805 # only patches with _$ARCH_ or _all_ in their filenames are applied.
806 for file in `ls -A ${x}`
807 do 1131 do
808 debug-print "${FUNCNAME}: parsing in subdir: file ${file}" 1132 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
809 if [ -f "${x}/${file}" -a "${file}" != "${file/_all_}" -o \ 1133 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
810 "${file}" != "${file/_$ARCH_}" ] 1134 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
811 then
812 list2="${list2} ${x}/${file}"
813 fi
814 done 1135 done
815 list="`echo ${list2} | sort` ${list}" 1136 fi
1137 echo ""
1138 else
1139 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1140 fi
1141}
1142
1143# @FUNCTION: make_session_desktop
1144# @USAGE: <title> <command> [command args...]
1145# @DESCRIPTION:
1146# Make a GDM/KDM Session file. The title is the file to execute to start the
1147# Window Manager. The command is the name of the Window Manager.
1148#
1149# You can set the name of the file via the ${wm} variable.
1150make_session_desktop() {
1151 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
1152 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
1153
1154 local title=$1
1155 local command=$2
1156 local desktop=${T}/${wm:-${PN}}.desktop
1157 shift 2
1158
1159 cat <<-EOF > "${desktop}"
1160 [Desktop Entry]
1161 Name=${title}
1162 Comment=This session logs you into ${title}
1163 Exec=${command} $*
1164 TryExec=${command}
1165 Type=XSession
1166 EOF
1167
1168 (
1169 # wrap the env here so that the 'insinto' call
1170 # doesn't corrupt the env of the caller
1171 insinto /usr/share/xsessions
1172 doins "${desktop}"
1173 )
1174}
1175
1176# @FUNCTION: domenu
1177# @USAGE: <menus>
1178# @DESCRIPTION:
1179# Install the list of .desktop menu files into the appropriate directory
1180# (/usr/share/applications).
1181domenu() {
1182 (
1183 # wrap the env here so that the 'insinto' call
1184 # doesn't corrupt the env of the caller
1185 local i j ret=0
1186 insinto /usr/share/applications
1187 for i in "$@" ; do
1188 if [[ -f ${i} ]] ; then
1189 doins "${i}"
1190 ((ret+=$?))
1191 elif [[ -d ${i} ]] ; then
1192 for j in "${i}"/*.desktop ; do
1193 doins "${j}"
1194 ((ret+=$?))
1195 done
816 else 1196 else
817 die "Couldn't find ${x}" 1197 ((++ret))
818 fi 1198 fi
819 done 1199 done
1200 exit ${ret}
1201 )
1202}
820 1203
821 debug-print "${FUNCNAME}: final list of patches: ${list}" 1204# @FUNCTION: newmenu
1205# @USAGE: <menu> <newname>
1206# @DESCRIPTION:
1207# Like all other new* functions, install the specified menu as newname.
1208newmenu() {
1209 (
1210 # wrap the env here so that the 'insinto' call
1211 # doesn't corrupt the env of the caller
1212 insinto /usr/share/applications
1213 newins "$@"
1214 )
1215}
822 1216
823 for x in ${list}; 1217# @FUNCTION: doicon
824 do 1218# @USAGE: <list of icons>
825 debug-print "${FUNCNAME}: processing ${x}" 1219# @DESCRIPTION:
826 # deal with compressed files. /usr/bin/file is in the system profile, or should be. 1220# Install the list of icons into the icon directory (/usr/share/pixmaps).
827 case "`/usr/bin/file -b ${x}`" in 1221# This is useful in conjunction with creating desktop/menu files.
828 *gzip*) 1222doicon() {
829 patchfile="${T}/current.patch" 1223 (
830 ungzip -c "${x}" > "${patchfile}" 1224 # wrap the env here so that the 'insinto' call
831 ;; 1225 # doesn't corrupt the env of the caller
832 *bzip2*) 1226 local i j ret
833 patchfile="${T}/current.patch" 1227 insinto /usr/share/pixmaps
834 bunzip2 -c "${x}" > "${patchfile}" 1228 for i in "$@" ; do
835 ;; 1229 if [[ -f ${i} ]] ; then
836 *text*) 1230 doins "${i}"
837 patchfile="${x}" 1231 ((ret+=$?))
838 ;; 1232 elif [[ -d ${i} ]] ; then
839 *) 1233 for j in "${i}"/*.png ; do
840 die "Could not determine filetype of patch ${x}" 1234 doins "${j}"
841 ;; 1235 ((ret+=$?))
842 esac
843 debug-print "${FUNCNAME}: patchfile=${patchfile}"
844
845 # determine patchlevel. supports p0 and higher with either $S or $WORKDIR as base.
846 target="`/bin/grep -m 1 '^+++ ' ${patchfile}`"
847 debug-print "${FUNCNAME}: raw target=${target}"
848 # strip target down to the path/filename, remove leading +++
849 target="${target/+++ }"; target="${target%% *}"
850 # duplicate slashes are discarded by patch wrt the patchlevel. therefore we need
851 # to discard them as well to calculate the correct patchlevel.
852 target="${target//\/\//\/}"
853 debug-print "${FUNCNAME}: stripped target=${target}"
854
855 # look for target
856 for basedir in "${S}" "${WORKDIR}" "${PWD}"; do
857 debug-print "${FUNCNAME}: looking in basedir=${basedir}"
858 cd "${basedir}"
859
860 # try stripping leading directories
861 target2="${target}"
862 plevel=0
863 debug-print "${FUNCNAME}: trying target2=${target2}, plevel=${plevel}"
864 while [ ! -f "${target2}" ]
865 do
866 target2="${target2#*/}" # removes piece of target2 upto the first occurence of /
867 plevel=$((plevel+1))
868 debug-print "${FUNCNAME}: trying target2=${target2}, plevel=${plevel}"
869 [ "${target2}" == "${target2/\/}" ] && break
870 done 1236 done
871 test -f "${target2}" && break 1237 else
872 1238 ((++ret))
873 # try stripping filename - needed to support patches creating new files 1239 fi
874 target2="${target%/*}"
875 plevel=0
876 debug-print "${FUNCNAME}: trying target2=${target2}, plevel=${plevel}"
877 while [ ! -d "${target2}" ]
878 do
879 target2="${target2#*/}" # removes piece of target2 upto the first occurence of /
880 plevel=$((plevel+1))
881 debug-print "${FUNCNAME}: trying target2=${target2}, plevel=${plevel}"
882 [ "${target2}" == "${target2/\/}" ] && break
883 done
884 test -d "${target2}" && break
885
886 done
887
888 test -f "${basedir}/${target2}" || test -d "${basedir}/${target2}" \
889 || die "Could not determine patchlevel for ${x}"
890 debug-print "${FUNCNAME}: determined plevel=${plevel}"
891 # do the patching
892 ebegin "Applying patch ${x##*/}..."
893 /usr/bin/patch -p${plevel} < "${patchfile}" > /dev/null \
894 || die "Failed to apply patch ${x}"
895 eend $?
896
897 done 1240 done
898 1241 exit ${ret}
1242 )
899} 1243}
900 1244
1245# @FUNCTION: newicon
1246# @USAGE: <icon> <newname>
1247# @DESCRIPTION:
1248# Like all other new* functions, install the specified icon as newname.
1249newicon() {
1250 (
1251 # wrap the env here so that the 'insinto' call
1252 # doesn't corrupt the env of the caller
1253 insinto /usr/share/pixmaps
1254 newins "$@"
1255 )
1256}
1257
1258# for internal use only (unpack_pdv and unpack_makeself)
1259find_unpackable_file() {
1260 local src=$1
1261 if [[ -z ${src} ]] ; then
1262 src=${DISTDIR}/${A}
1263 else
1264 if [[ -e ${DISTDIR}/${src} ]] ; then
1265 src=${DISTDIR}/${src}
1266 elif [[ -e ${PWD}/${src} ]] ; then
1267 src=${PWD}/${src}
1268 elif [[ -e ${src} ]] ; then
1269 src=${src}
1270 fi
1271 fi
1272 [[ ! -e ${src} ]] && return 1
1273 echo "${src}"
1274}
1275
1276# @FUNCTION: unpack_pdv
1277# @USAGE: <file to unpack> <size of off_t>
1278# @DESCRIPTION:
1279# Unpack those pesky pdv generated files ...
1280# They're self-unpacking programs with the binary package stuffed in
1281# the middle of the archive. Valve seems to use it a lot ... too bad
1282# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1283#
1284# You have to specify the off_t size ... I have no idea how to extract that
1285# information out of the binary executable myself. Basically you pass in
1286# the size of the off_t type (in bytes) on the machine that built the pdv
1287# archive.
1288#
1289# One way to determine this is by running the following commands:
1290#
1291# @CODE
1292# strings <pdv archive> | grep lseek
1293# strace -elseek <pdv archive>
1294# @CODE
1295#
1296# Basically look for the first lseek command (we do the strings/grep because
1297# sometimes the function call is _llseek or something) and steal the 2nd
1298# parameter. Here is an example:
1299#
1300# @CODE
1301# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1302# lseek
1303# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1304# lseek(3, -4, SEEK_END) = 2981250
1305# @CODE
1306#
1307# Thus we would pass in the value of '4' as the second parameter.
1308unpack_pdv() {
1309 local src=$(find_unpackable_file "$1")
1310 local sizeoff_t=$2
1311
1312 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1313 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1314
1315 local shrtsrc=$(basename "${src}")
1316 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1317 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1318 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1319
1320 # grab metadata for debug reasons
1321 local metafile=$(emktemp)
1322 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1323
1324 # rip out the final file name from the metadata
1325 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1326 datafile=$(basename "${datafile}")
1327
1328 # now lets uncompress/untar the file if need be
1329 local tmpfile=$(emktemp)
1330 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1331
1332 local iscompressed=$(file -b "${tmpfile}")
1333 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1334 iscompressed=1
1335 mv ${tmpfile}{,.Z}
1336 gunzip ${tmpfile}
1337 else
1338 iscompressed=0
1339 fi
1340 local istar=$(file -b "${tmpfile}")
1341 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1342 istar=1
1343 else
1344 istar=0
1345 fi
1346
1347 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1348 #dd if=${src} ibs=${metaskip} count=1 \
1349 # | dd ibs=${tailskip} skip=1 \
1350 # | gzip -dc \
1351 # > ${datafile}
1352 if [ ${iscompressed} -eq 1 ] ; then
1353 if [ ${istar} -eq 1 ] ; then
1354 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1355 | head -c $((${metaskip}-${tailskip})) \
1356 | tar -xzf -
1357 else
1358 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1359 | head -c $((${metaskip}-${tailskip})) \
1360 | gzip -dc \
1361 > ${datafile}
1362 fi
1363 else
1364 if [ ${istar} -eq 1 ] ; then
1365 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1366 | head -c $((${metaskip}-${tailskip})) \
1367 | tar --no-same-owner -xf -
1368 else
1369 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1370 | head -c $((${metaskip}-${tailskip})) \
1371 > ${datafile}
1372 fi
1373 fi
1374 true
1375 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1376 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1377}
1378
1379# @FUNCTION: unpack_makeself
1380# @USAGE: [file to unpack] [offset] [tail|dd]
1381# @DESCRIPTION:
901# Unpack those pesky makeself generated files ... 1382# Unpack those pesky makeself generated files ...
902# They're shell scripts with the binary package tagged onto 1383# They're shell scripts with the binary package tagged onto
903# the end of the archive. Loki utilized the format as does 1384# the end of the archive. Loki utilized the format as does
904# many other game companies. 1385# many other game companies.
905# 1386#
906# Usage: unpack_makeself [file to unpack] [offset] 1387# If the file is not specified, then ${A} is used. If the
907# - If the file is not specified then unpack will utilize ${A}.
908# - If the offset is not specified then we will attempt to extract 1388# offset is not specified then we will attempt to extract
909# the proper offset from the script itself. 1389# the proper offset from the script itself.
910unpack_makeself() { 1390unpack_makeself() {
911 local src="$1" 1391 local src_input=${1:-${A}}
1392 local src=$(find_unpackable_file "${src_input}")
912 local skip="$2" 1393 local skip=$2
1394 local exe=$3
913 1395
914 if [ -z "${src}" ] 1396 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
915 then
916 src="${DISTDIR}/${A}"
917 else
918 if [ -e "${DISTDIR}/${src}" ]
919 then
920 src="${DISTDIR}/${src}"
921 elif [ -e "${PWD}/${src}" ]
922 then
923 src="${PWD}/${src}"
924 elif [ -e "${src}" ]
925 then
926 src="${src}"
927 fi
928 fi
929 [ ! -e "${src}" ] && die "Could not find requested makeself archive ${src}"
930 1397
931 local shrtsrc="`basename ${src}`" 1398 local shrtsrc=$(basename "${src}")
932 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1399 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
933 if [ -z "${skip}" ] 1400 if [[ -z ${skip} ]] ; then
934 then
935 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1401 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
936 local skip=0 1402 local skip=0
1403 exe=tail
937 case ${ver} in 1404 case ${ver} in
938 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1405 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
939 skip=`grep -a ^skip= ${src} | cut -d= -f2` 1406 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
940 ;; 1407 ;;
941 2.0|2.0.1) 1408 2.0|2.0.1)
942 skip=`grep -a ^$'\t'tail ${src} | awk '{print $2}' | cut -b2-` 1409 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
943 ;; 1410 ;;
944 2.1.1) 1411 2.1.1)
945 skip=`grep -a ^offset= ${src} | awk '{print $2}' | cut -b2-` 1412 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
946 let skip="skip + 1" 1413 (( skip++ ))
947 ;; 1414 ;;
948 2.1.2) 1415 2.1.2)
949 skip=`grep -a ^offset= ${src} | awk '{print $3}' | head -n 1` 1416 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
950 let skip="skip + 1" 1417 (( skip++ ))
951 ;; 1418 ;;
952 2.1.3) 1419 2.1.3)
953 skip=`grep -a ^offset= ${src} | awk '{print $3}'` 1420 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
954 let skip="skip + 1" 1421 (( skip++ ))
1422 ;;
1423 2.1.4|2.1.5)
1424 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1425 skip=$(head -n ${skip} "${src}" | wc -c)
1426 exe="dd"
955 ;; 1427 ;;
956 *) 1428 *)
957 eerror "I'm sorry, but I was unable to support the Makeself file." 1429 eerror "I'm sorry, but I was unable to support the Makeself file."
958 eerror "The version I detected was '${ver}'." 1430 eerror "The version I detected was '${ver}'."
959 eerror "Please file a bug about the file ${shrtsrc} at" 1431 eerror "Please file a bug about the file ${shrtsrc} at"
961 die "makeself version '${ver}' not supported" 1433 die "makeself version '${ver}' not supported"
962 ;; 1434 ;;
963 esac 1435 esac
964 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1436 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
965 fi 1437 fi
1438 case ${exe} in
1439 tail) exe="tail -n +${skip} '${src}'";;
1440 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1441 *) die "makeself cant handle exe '${exe}'"
1442 esac
966 1443
967 # lets grab the first few bytes of the file to figure out what kind of archive it is 1444 # lets grab the first few bytes of the file to figure out what kind of archive it is
968 local tmpfile="`mymktemp ${T}`" 1445 local filetype tmpfile=$(emktemp)
969 tail -n +${skip} ${src} 2>/dev/null | head -c 512 > ${tmpfile} 1446 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
970 local filetype="`file -b ${tmpfile}`" 1447 filetype=$(file -b "${tmpfile}") || die
971 case ${filetype} in 1448 case ${filetype} in
972 *tar\ archive) 1449 *tar\ archive*)
973 tail -n +${skip} ${src} | tar -xf - 1450 eval ${exe} | tar --no-same-owner -xf -
974 ;; 1451 ;;
975 bzip2*) 1452 bzip2*)
976 tail -n +${skip} ${src} | bzip2 -dc | tar -xf - 1453 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
977 ;; 1454 ;;
978 gzip*) 1455 gzip*)
979 tail -n +${skip} ${src} | tar -xzf - 1456 eval ${exe} | tar --no-same-owner -xzf -
1457 ;;
1458 compress*)
1459 eval ${exe} | gunzip | tar --no-same-owner -xf -
980 ;; 1460 ;;
981 *) 1461 *)
1462 eerror "Unknown filetype \"${filetype}\" ?"
982 false 1463 false
983 ;; 1464 ;;
984 esac 1465 esac
985 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1466 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
986} 1467}
987 1468
1469# @FUNCTION: check_license
1470# @USAGE: [license]
1471# @DESCRIPTION:
988# Display a license for user to accept. 1472# Display a license for user to accept. If no license is
989#
990# Usage: check_license [license]
991# - If the file is not specified then ${LICENSE} is used. 1473# specified, then ${LICENSE} is used.
992check_license() { 1474check_license() {
993 local lic=$1 1475 local lic=$1
994 if [ -z "${lic}" ] ; then 1476 if [ -z "${lic}" ] ; then
995 lic="${PORTDIR}/licenses/${LICENSE}" 1477 lic="${PORTDIR}/licenses/${LICENSE}"
996 else 1478 else
997 if [ -e "${PORTDIR}/licenses/${src}" ] ; then 1479 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
998 lic="${PORTDIR}/licenses/${src}" 1480 lic="${PORTDIR}/licenses/${lic}"
999 elif [ -e "${PWD}/${src}" ] ; then 1481 elif [ -e "${PWD}/${lic}" ] ; then
1000 lic="${PWD}/${src}" 1482 lic="${PWD}/${lic}"
1001 elif [ -e "${src}" ] ; then 1483 elif [ -e "${lic}" ] ; then
1002 lic="${src}" 1484 lic="${lic}"
1003 fi
1004 fi 1485 fi
1005 [ ! -f "${lic}" ] && die "Could not find requested license ${src}" 1486 fi
1006 local l="`basename ${lic}`" 1487 local l="`basename ${lic}`"
1007 1488
1008 # here is where we check for the licenses the user already 1489 # here is where we check for the licenses the user already
1009 # accepted ... if we don't find a match, we make the user accept 1490 # accepted ... if we don't find a match, we make the user accept
1010 local alic 1491 local alic
1492 eshopts_push -o noglob # so that bash doesn't expand "*"
1011 for alic in ${ACCEPT_LICENSE} ; do 1493 for alic in ${ACCEPT_LICENSE} ; do
1012 [ "${alic}" == "*" ] && return 0 1494 if [[ ${alic} == ${l} ]]; then
1013 [ "${alic}" == "${l}" ] && return 0 1495 eshopts_pop
1496 return 0
1497 fi
1014 done 1498 done
1499 eshopts_pop
1500 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1015 1501
1016 local licmsg="`mymktemp ${T}`" 1502 local licmsg=$(emktemp)
1017 cat << EOF > ${licmsg} 1503 cat <<-EOF > ${licmsg}
1018********************************************************** 1504 **********************************************************
1019The following license outlines the terms of use of this 1505 The following license outlines the terms of use of this
1020package. You MUST accept this license for installation to 1506 package. You MUST accept this license for installation to
1021continue. When you are done viewing, hit 'q'. If you 1507 continue. When you are done viewing, hit 'q'. If you
1022CTRL+C out of this, the install will not run! 1508 CTRL+C out of this, the install will not run!
1023********************************************************** 1509 **********************************************************
1024 1510
1025EOF 1511 EOF
1026 cat ${lic} >> ${licmsg} 1512 cat ${lic} >> ${licmsg}
1027 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1513 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1028 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1514 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1029 read alic 1515 read alic
1030 case ${alic} in 1516 case ${alic} in
1036 eerror "You MUST accept the license to continue! Exiting!" 1522 eerror "You MUST accept the license to continue! Exiting!"
1037 die "Failed to accept license" 1523 die "Failed to accept license"
1038 ;; 1524 ;;
1039 esac 1525 esac
1040} 1526}
1527
1528# @FUNCTION: cdrom_get_cds
1529# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1530# @DESCRIPTION:
1531# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1532# the whole 'non-interactive' policy, but damnit I want CD support !
1533#
1534# With these cdrom functions we handle all the user interaction and
1535# standardize everything. All you have to do is call cdrom_get_cds()
1536# and when the function returns, you can assume that the cd has been
1537# found at CDROM_ROOT.
1538#
1539# The function will attempt to locate a cd based upon a file that is on
1540# the cd. The more files you give this function, the more cds
1541# the cdrom functions will handle.
1542#
1543# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1544# etc... If you want to give the cds better names, then just export
1545# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1546# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1547# also use the CDROM_NAME_SET bash array.
1548#
1549# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1550cdrom_get_cds() {
1551 # first we figure out how many cds we're dealing with by
1552 # the # of files they gave us
1553 local cdcnt=0
1554 local f=
1555 for f in "$@" ; do
1556 ((++cdcnt))
1557 export CDROM_CHECK_${cdcnt}="$f"
1558 done
1559 export CDROM_TOTAL_CDS=${cdcnt}
1560 export CDROM_CURRENT_CD=1
1561
1562 # now we see if the user gave use CD_ROOT ...
1563 # if they did, let's just believe them that it's correct
1564 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1565 local var=
1566 cdcnt=0
1567 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1568 ((++cdcnt))
1569 var="CD_ROOT_${cdcnt}"
1570 [[ -z ${!var} ]] && var="CD_ROOT"
1571 if [[ -z ${!var} ]] ; then
1572 eerror "You must either use just the CD_ROOT"
1573 eerror "or specify ALL the CD_ROOT_X variables."
1574 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1575 die "could not locate CD_ROOT_${cdcnt}"
1576 fi
1577 done
1578 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1579 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1580 export CDROM_SET=-1
1581 for f in ${CDROM_CHECK_1//:/ } ; do
1582 ((++CDROM_SET))
1583 [[ -e ${CDROM_ROOT}/${f} ]] && break
1584 done
1585 export CDROM_MATCH=${f}
1586 return
1587 fi
1588
1589 # User didn't help us out so lets make sure they know they can
1590 # simplify the whole process ...
1591 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1592 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1593 echo
1594 einfo "If you do not have the CD, but have the data files"
1595 einfo "mounted somewhere on your filesystem, just export"
1596 einfo "the variable CD_ROOT so that it points to the"
1597 einfo "directory containing the files."
1598 echo
1599 einfo "For example:"
1600 einfo "export CD_ROOT=/mnt/cdrom"
1601 echo
1602 else
1603 if [[ -n ${CDROM_NAME_SET} ]] ; then
1604 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1605 cdcnt=0
1606 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1607 ((++cdcnt))
1608 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1609 done
1610 fi
1611
1612 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1613 cdcnt=0
1614 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1615 ((++cdcnt))
1616 var="CDROM_NAME_${cdcnt}"
1617 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1618 done
1619 echo
1620 einfo "If you do not have the CDs, but have the data files"
1621 einfo "mounted somewhere on your filesystem, just export"
1622 einfo "the following variables so they point to the right place:"
1623 einfon ""
1624 cdcnt=0
1625 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1626 ((++cdcnt))
1627 echo -n " CD_ROOT_${cdcnt}"
1628 done
1629 echo
1630 einfo "Or, if you have all the files in the same place, or"
1631 einfo "you only have one cdrom, you can export CD_ROOT"
1632 einfo "and that place will be used as the same data source"
1633 einfo "for all the CDs."
1634 echo
1635 einfo "For example:"
1636 einfo "export CD_ROOT_1=/mnt/cdrom"
1637 echo
1638 fi
1639
1640 export CDROM_SET=""
1641 export CDROM_CURRENT_CD=0
1642 cdrom_load_next_cd
1643}
1644
1645# @FUNCTION: cdrom_load_next_cd
1646# @DESCRIPTION:
1647# Some packages are so big they come on multiple CDs. When you're done reading
1648# files off a CD and want access to the next one, just call this function.
1649# Again, all the messy details of user interaction are taken care of for you.
1650# Once this returns, just read the variable CDROM_ROOT for the location of the
1651# mounted CD. Note that you can only go forward in the CD list, so make sure
1652# you only call this function when you're done using the current CD.
1653cdrom_load_next_cd() {
1654 local var
1655 ((++CDROM_CURRENT_CD))
1656
1657 unset CDROM_ROOT
1658 var=CD_ROOT_${CDROM_CURRENT_CD}
1659 [[ -z ${!var} ]] && var="CD_ROOT"
1660 if [[ -z ${!var} ]] ; then
1661 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1662 _cdrom_locate_file_on_cd ${!var}
1663 else
1664 export CDROM_ROOT=${!var}
1665 fi
1666
1667 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1668}
1669
1670# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1671# functions. this should *never* be called from an ebuild.
1672# all it does is try to locate a give file on a cd ... if the cd isn't
1673# found, then a message asking for the user to insert the cdrom will be
1674# displayed and we'll hang out here until:
1675# (1) the file is found on a mounted cdrom
1676# (2) the user hits CTRL+C
1677_cdrom_locate_file_on_cd() {
1678 local mline=""
1679 local showedmsg=0 showjolietmsg=0
1680
1681 while [[ -z ${CDROM_ROOT} ]] ; do
1682 local i=0
1683 local -a cdset=(${*//:/ })
1684 if [[ -n ${CDROM_SET} ]] ; then
1685 cdset=(${cdset[${CDROM_SET}]})
1686 fi
1687
1688 while [[ -n ${cdset[${i}]} ]] ; do
1689 local dir=$(dirname ${cdset[${i}]})
1690 local file=$(basename ${cdset[${i}]})
1691
1692 local point= node= fs= foo=
1693 while read point node fs foo ; do
1694 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1695 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1696 && continue
1697 point=${point//\040/ }
1698 [[ ! -d ${point}/${dir} ]] && continue
1699 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1700 export CDROM_ROOT=${point}
1701 export CDROM_SET=${i}
1702 export CDROM_MATCH=${cdset[${i}]}
1703 return
1704 done <<< "$(get_mounts)"
1705
1706 ((++i))
1707 done
1708
1709 echo
1710 if [[ ${showedmsg} -eq 0 ]] ; then
1711 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1712 if [[ -z ${CDROM_NAME} ]] ; then
1713 einfo "Please insert+mount the cdrom for ${PN} now !"
1714 else
1715 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1716 fi
1717 else
1718 if [[ -z ${CDROM_NAME_1} ]] ; then
1719 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1720 else
1721 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1722 einfo "Please insert+mount the ${!var} cdrom now !"
1723 fi
1724 fi
1725 showedmsg=1
1726 fi
1727 einfo "Press return to scan for the cd again"
1728 einfo "or hit CTRL+C to abort the emerge."
1729 echo
1730 if [[ ${showjolietmsg} -eq 0 ]] ; then
1731 showjolietmsg=1
1732 else
1733 ewarn "If you are having trouble with the detection"
1734 ewarn "of your CD, it is possible that you do not have"
1735 ewarn "Joliet support enabled in your kernel. Please"
1736 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1737 ebeep 5
1738 fi
1739 read || die "something is screwed with your system"
1740 done
1741}
1742
1743# @FUNCTION: strip-linguas
1744# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1745# @DESCRIPTION:
1746# Make sure that LINGUAS only contains languages that
1747# a package can support. The first form allows you to
1748# specify a list of LINGUAS. The -i builds a list of po
1749# files found in all the directories and uses the
1750# intersection of the lists. The -u builds a list of po
1751# files found in all the directories and uses the union
1752# of the lists.
1753strip-linguas() {
1754 local ls newls nols
1755 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1756 local op=$1; shift
1757 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1758 local d f
1759 for d in "$@" ; do
1760 if [[ ${op} == "-u" ]] ; then
1761 newls=${ls}
1762 else
1763 newls=""
1764 fi
1765 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1766 if [[ ${op} == "-i" ]] ; then
1767 has ${f} ${ls} && newls="${newls} ${f}"
1768 else
1769 has ${f} ${ls} || newls="${newls} ${f}"
1770 fi
1771 done
1772 ls=${newls}
1773 done
1774 else
1775 ls="$@"
1776 fi
1777
1778 nols=""
1779 newls=""
1780 for f in ${LINGUAS} ; do
1781 if has ${f} ${ls} ; then
1782 newls="${newls} ${f}"
1783 else
1784 nols="${nols} ${f}"
1785 fi
1786 done
1787 [[ -n ${nols} ]] \
1788 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1789 export LINGUAS=${newls:1}
1790}
1791
1792# @FUNCTION: preserve_old_lib
1793# @USAGE: <libs to preserve> [more libs]
1794# @DESCRIPTION:
1795# These functions are useful when a lib in your package changes ABI SONAME.
1796# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1797# would break packages that link against it. Most people get around this
1798# by using the portage SLOT mechanism, but that is not always a relevant
1799# solution, so instead you can call this from pkg_preinst. See also the
1800# preserve_old_lib_notify function.
1801preserve_old_lib() {
1802 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1803 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1804 die "Invalid preserve_old_lib() usage"
1805 fi
1806 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1807
1808 # let portage worry about it
1809 has preserve-libs ${FEATURES} && return 0
1810
1811 local lib dir
1812 for lib in "$@" ; do
1813 [[ -e ${ROOT}/${lib} ]] || continue
1814 dir=${lib%/*}
1815 dodir ${dir} || die "dodir ${dir} failed"
1816 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1817 touch "${D}"/${lib}
1818 done
1819}
1820
1821# @FUNCTION: preserve_old_lib_notify
1822# @USAGE: <libs to notify> [more libs]
1823# @DESCRIPTION:
1824# Spit helpful messages about the libraries preserved by preserve_old_lib.
1825preserve_old_lib_notify() {
1826 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1827 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1828 die "Invalid preserve_old_lib_notify() usage"
1829 fi
1830
1831 # let portage worry about it
1832 has preserve-libs ${FEATURES} && return 0
1833
1834 local lib notice=0
1835 for lib in "$@" ; do
1836 [[ -e ${ROOT}/${lib} ]] || continue
1837 if [[ ${notice} -eq 0 ]] ; then
1838 notice=1
1839 ewarn "Old versions of installed libraries were detected on your system."
1840 ewarn "In order to avoid breaking packages that depend on these old libs,"
1841 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1842 ewarn "in order to remove these old dependencies. If you do not have this"
1843 ewarn "helper program, simply emerge the 'gentoolkit' package."
1844 ewarn
1845 fi
1846 # temp hack for #348634 #357225
1847 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1848 ewarn " # revdep-rebuild --library '${lib}'"
1849 done
1850 if [[ ${notice} -eq 1 ]] ; then
1851 ewarn
1852 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1853 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1854 for lib in "$@" ; do
1855 ewarn " # rm '${lib}'"
1856 done
1857 fi
1858}
1859
1860# @FUNCTION: built_with_use
1861# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1862# @DESCRIPTION:
1863#
1864# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1865#
1866# A temporary hack until portage properly supports DEPENDing on USE
1867# flags being enabled in packages. This will check to see if the specified
1868# DEPEND atom was built with the specified list of USE flags. The
1869# --missing option controls the behavior if called on a package that does
1870# not actually support the defined USE flags (aka listed in IUSE).
1871# The default is to abort (call die). The -a and -o flags control
1872# the requirements of the USE flags. They correspond to "and" and "or"
1873# logic. So the -a flag means all listed USE flags must be enabled
1874# while the -o flag means at least one of the listed IUSE flags must be
1875# enabled. The --hidden option is really for internal use only as it
1876# means the USE flag we're checking is hidden expanded, so it won't be found
1877# in IUSE like normal USE flags.
1878#
1879# Remember that this function isn't terribly intelligent so order of optional
1880# flags matter.
1881built_with_use() {
1882 local hidden="no"
1883 if [[ $1 == "--hidden" ]] ; then
1884 hidden="yes"
1885 shift
1886 fi
1887
1888 local missing_action="die"
1889 if [[ $1 == "--missing" ]] ; then
1890 missing_action=$2
1891 shift ; shift
1892 case ${missing_action} in
1893 true|false|die) ;;
1894 *) die "unknown action '${missing_action}'";;
1895 esac
1896 fi
1897
1898 local opt=$1
1899 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1900
1901 local PKG=$(best_version $1)
1902 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1903 shift
1904
1905 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1906 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1907
1908 # if the IUSE file doesn't exist, the read will error out, we need to handle
1909 # this gracefully
1910 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1911 case ${missing_action} in
1912 true) return 0;;
1913 false) return 1;;
1914 die) die "Unable to determine what USE flags $PKG was built with";;
1915 esac
1916 fi
1917
1918 if [[ ${hidden} == "no" ]] ; then
1919 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1920 # Don't check USE_EXPAND #147237
1921 local expand
1922 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1923 if [[ $1 == ${expand}_* ]] ; then
1924 expand=""
1925 break
1926 fi
1927 done
1928 if [[ -n ${expand} ]] ; then
1929 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1930 case ${missing_action} in
1931 true) return 0;;
1932 false) return 1;;
1933 die) die "$PKG does not actually support the $1 USE flag!";;
1934 esac
1935 fi
1936 fi
1937 fi
1938
1939 local USE_BUILT=$(<${USEFILE})
1940 while [[ $# -gt 0 ]] ; do
1941 if [[ ${opt} = "-o" ]] ; then
1942 has $1 ${USE_BUILT} && return 0
1943 else
1944 has $1 ${USE_BUILT} || return 1
1945 fi
1946 shift
1947 done
1948 [[ ${opt} = "-a" ]]
1949}
1950
1951# @FUNCTION: epunt_cxx
1952# @USAGE: [dir to scan]
1953# @DESCRIPTION:
1954# Many configure scripts wrongly bail when a C++ compiler could not be
1955# detected. If dir is not specified, then it defaults to ${S}.
1956#
1957# http://bugs.gentoo.org/73450
1958epunt_cxx() {
1959 local dir=$1
1960 [[ -z ${dir} ]] && dir=${S}
1961 ebegin "Removing useless C++ checks"
1962 local f
1963 find "${dir}" -name configure | while read f ; do
1964 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1965 done
1966 eend 0
1967}
1968
1969# @FUNCTION: make_wrapper
1970# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1971# @DESCRIPTION:
1972# Create a shell wrapper script named wrapper in installpath
1973# (defaults to the bindir) to execute target (default of wrapper) by
1974# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1975# libpaths followed by optionally changing directory to chdir.
1976make_wrapper() {
1977 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1978 local tmpwrapper=$(emktemp)
1979 # We don't want to quote ${bin} so that people can pass complex
1980 # things as $bin ... "./someprog --args"
1981 cat << EOF > "${tmpwrapper}"
1982#!/bin/sh
1983cd "${chdir:-.}"
1984if [ -n "${libdir}" ] ; then
1985 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1986 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1987 else
1988 export LD_LIBRARY_PATH="${libdir}"
1989 fi
1990fi
1991exec ${bin} "\$@"
1992EOF
1993 chmod go+rx "${tmpwrapper}"
1994 if [[ -n ${path} ]] ; then
1995 (
1996 exeinto "${path}"
1997 newexe "${tmpwrapper}" "${wrapper}"
1998 ) || die
1999 else
2000 newbin "${tmpwrapper}" "${wrapper}" || die
2001 fi
2002}
2003
2004# @FUNCTION: path_exists
2005# @USAGE: [-a|-o] <paths>
2006# @DESCRIPTION:
2007# Check if the specified paths exist. Works for all types of paths
2008# (files/dirs/etc...). The -a and -o flags control the requirements
2009# of the paths. They correspond to "and" and "or" logic. So the -a
2010# flag means all the paths must exist while the -o flag means at least
2011# one of the paths must exist. The default behavior is "and". If no
2012# paths are specified, then the return value is "false".
2013path_exists() {
2014 local opt=$1
2015 [[ ${opt} == -[ao] ]] && shift || opt="-a"
2016
2017 # no paths -> return false
2018 # same behavior as: [[ -e "" ]]
2019 [[ $# -eq 0 ]] && return 1
2020
2021 local p r=0
2022 for p in "$@" ; do
2023 [[ -e ${p} ]]
2024 : $(( r += $? ))
2025 done
2026
2027 case ${opt} in
2028 -a) return $(( r != 0 )) ;;
2029 -o) return $(( r == $# )) ;;
2030 esac
2031}
2032
2033# @FUNCTION: in_iuse
2034# @USAGE: <flag>
2035# @DESCRIPTION:
2036# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
2037# as necessary.
2038#
2039# Note that this function should not be used in the global scope.
2040in_iuse() {
2041 debug-print-function ${FUNCNAME} "${@}"
2042 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
2043
2044 local flag=${1}
2045 local liuse=( ${IUSE} )
2046
2047 has "${flag}" "${liuse[@]#[+-]}"
2048}
2049
2050# @FUNCTION: use_if_iuse
2051# @USAGE: <flag>
2052# @DESCRIPTION:
2053# Return true if the given flag is in USE and IUSE.
2054#
2055# Note that this function should not be used in the global scope.
2056use_if_iuse() {
2057 in_iuse $1 || return 1
2058 use $1
2059}
2060
2061# @FUNCTION: usex
2062# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
2063# @DESCRIPTION:
2064# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
2065# otherwise echo [false output][false suffix] (defaults to "no").
2066usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963

Legend:
Removed from v.1.69  
changed lines
  Added in v.1.367

  ViewVC Help
Powered by ViewVC 1.1.20